/*
 * $Id: hashtable.h,v 1.3 2001/08/25 02:56:37 kenta Exp $
 *
 * Copyright 2001 Kenta Cho. All rights reserved.
 */

/**
 * Hashtable utility functions header file.
 *
 * @version $Revision: 1.3 $
 */
#include <stdio.h>

#define KEY_SIZE 64
#define KEY_LENGTH 96
#define ELEMENT_SIZE 1

#define ALL_ELEMENTS_SIZE KEY_SIZE*ELEMENT_SIZE

typedef struct {
  char keys[ALL_ELEMENTS_SIZE][KEY_LENGTH];
  int valid[ALL_ELEMENTS_SIZE];
  void *elements[ALL_ELEMENTS_SIZE];
  size_t elementSize;
  int enumCnt;
} Hashtable;

void initHash(Hashtable *ht, size_t, int);
int hashFunc(char *key);
void* check(Hashtable *ht, char *key, int *valid);
void* checkByIndex(Hashtable *ht, int index);
void* get(Hashtable *ht, char *key, int *valid, int *new);
void startEnumeration(Hashtable *ht);
int hasMoreElements(Hashtable *ht);
void* nextElement(Hashtable *ht);
void deleteElement(Hashtable *ht);
void save(Hashtable *ht, FILE *fp);
void load(Hashtable *ht, FILE *fp);
