#include "sjis2uni.h"

#define UNICODE_MAX 0x0ffff
static Uint16 table[UNICODE_MAX];
static int loaded=0;
#define sjis2uniFilename "shiftjis.txt"

int sjis2uni_making_table(void){
	
	FILE *fp;
#define BUFMAX 4096
	char buf[BUFMAX],*p,*q;
	Uint16 index,value;
	
	memset(table,0,sizeof(table));
	
	fp=fopen(sjis2uniFilename,"rb");
	if(NULL==fp){
		fprintf(stderr,"can't open %s\n",sjis2uniFilename);
		return -1;
	}
	
	do{
		if(NULL==fgets(buf,BUFMAX,fp))break;
		if( strchr("\n\r#",*buf)!=NULL )continue;
		p=strtok(buf,"\r\n\t ");
		q=strtok(NULL,"\r\n\t ");
		if(p==NULL || q==NULL){
			fprintf(stderr,"%s\n",buf);
		}else{
			index=strtoul(p,NULL,16);
			value=strtoul(q,NULL,16);
			table[index]=value;
		}
	}while(1);
	fclose(fp);
	loaded=1;
}

void sjis2uni(char *src,Uint16 *dest){
	
	Uint16 index,value;
	Uint8 high,low;
	
	if(!loaded)sjis2uni_making_table();
	
	while(*src!=0){
		if(((unsigned char)*src)<128){
			
			index=*src;
			
		}else{
			
			high=*(Uint8 *)src;
			low=*(Uint8 *)(src+1);
			
			index=(high<<8)+low;
			
			src++;
			
		}
		src++;
		
		
		value=table[index];
		
//printf("%04x -> %04x\n",index,value);
		
		*dest++=value;
	}
	*dest=0;
}

